/*
 * Exercise 2: Main.java
 */
package ex2;

import javax.realtime.*;

public class Main {
    /** The instance of PeriodicNHRT you have to create in ImmortalMemory
     *  It is started in main()
     */
    private static PeriodicNHRT worker;
    
    static {
        // Allocation in static initializers occur within ImmortalMemory.
        // Initialize worker here
        PriorityParameters prio = new PriorityParameters(PriorityScheduler.instance().getMinPriority());
        RelativeTime period = new RelativeTime(5L, 0); // 5ms period
        PeriodicParameters pParams = new PeriodicParameters(period);
        worker = new PeriodicNHRT(prio, pParams, ImmortalMemory.instance());
    }
    
    /* DO NOT MODIFY THIS CODE */
    public static void main(String[] args) {
        // This generates a background load that will interfere with anything
        // not real-time, or requiring access to the heap
        BackgroundLoader b = new BackgroundLoader();
        b.start();
        worker.start();
        try {
            worker.join(60000); // should terminate in less than a minute
        }
        catch (InterruptedException _) { /*ignore*/}
        System.out.println("Application is shutting down ...");  
        b.shutdown();
        System.out.println("Application DONE");
        System.exit(0); // try to quit in case real-time thread runs too long        
    }

    /* DO NOT MODIFY THIS CODE */
    static {
	// force pre-initialization of the printf related libraries
	// in immortal memory so the NHRT can use them without
	// being delayed
	System.out.printf("Application started ...%n");
    }
    
}
