/*
 * Exercise 4: Main.java
 */
package ex5;

import javax.realtime.*;

public class Main {

    /** The instance of PeriodicAEH you have to create in ImmortalMemory
     */
    private static PeriodicAEH handler;

    /** The DataBuffer to be used
     */
    private static DataBuffer buffer = new DataBuffer();

    /** The Sensor to be used
     */
    private static Sensor sensor = new Sensor();

    static {
        // Allocation in static initializers occur within ImmortalMemory.

        // INSERT CODE: to create a new PeriodicAEH, passing in
        // suitable scheduling and release parameters, and the buffer and
        // sensor objects

        PriorityParameters prio = new PriorityParameters(PriorityScheduler.instance().getMinPriority());
        RelativeTime period = new RelativeTime(50L, 0); // 50ms period
        PeriodicParameters pParams = new PeriodicParameters(period);
        handler = new PeriodicAEH(prio, pParams, buffer, sensor);
    }
    
    public static void main(String[] args) {
        PeriodicTimer timer = null;
        ConsumerThread cons = new ConsumerThread(buffer);

        // INSERT CODE: to create a periodic timer that will release our handler
        timer = new PeriodicTimer(null, new RelativeTime(50,0), handler);

        // UNCOMMENT THIS LINE FOR FINAL TESTING
        cons.start();
        timer.start();

        /* DO NOT MODIFY THIS CODE */

        // Terminate the app after 60 seconds if the handler doesn't do it
        try {
            Thread.sleep(60000);
        }
        catch (InterruptedException ex) {
            // shouldn't happen
        }
        System.exit(-1);
    }

    /* DO NOT MODIFY THIS CODE */

    static {
        // force pre-initialization of the printf related libraries
        // in immortal memory so the no-heap entities can use them without
        // being delayed
        System.out.printf("Application started ...%n");
    }
    
}
